#ifndef __CRA_C_H
#define __CRA_C_H

#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>

extern FILE *cra_c_debug;

#ifndef __cplusplus
enum bool {false, true};
#ifndef T
typedef int bool;
#define T 1
#define NIL 0
#endif
#endif /* C++ */

/* Begin of automatic definitions by autoheader */
@TOP@
@BOTTOM@
/* End of automatic definitions by autoheader */

#ifndef __GNUC__
#define __PRETTY_FUNCTION__ "Unknown function"
#define __FUNCTION__ "Unknown function"
#define LOG
#else
#define LOG printf("[%s] ",__PRETTY_FUNCTION__)
#endif /* __GNUC__ */

char *strim_simple(char *s);
  
char *bits(unsigned long wert, int laenge);

void argcv(char *sp, int *argc, char *argv[], int max_argv);

char *tausenderpunkte(const char *const source, char *const target,
		      size_t bufsize, char dec, char group);

char *fpformat(char *const buf, size_t bufsize,
	       const char* const fmt, ...)
#ifdef __GNUC__
     __attribute__ ((format (printf,3,4)))
#endif
     ;

char *strdup_umlaute(const char *ps, int FLAGS);
#define UMLAUTE_ISO2E 1
  
/* Funktionalitaet identisch zu fgets, checkt aber, ob
   am Ende ein Newline ist.
   Cost: strlen auf diesen String wird durchgefuehrt
   */
char *save_fgets(char *buf, int size, FILE *f);

char *strassert(char* s);

void craerr(int flags, int retval, const char *fmt, ...)
#ifdef __GNUC__
     __attribute__ ((format (printf,3,4)))
#endif
     ;

#define CRAERR_PERROR 1
#define CRAERR_NOVERBOSE 2
#define CRAERR_NOEXIT 4
#define CRAERR_CORE 8

#define CRAERR_USAGE 64 /* Fehlercode, wenn kommandozeilenparameter falsch */
#define CRAERR_INPUT 65 /* Wenn anderer Input vom User keinen Sinn macht */
#define CRAERR_USERSYS 66 /* Systemfehler, der vom Benutzer zu beheben waere
			     (z.B. Permissions) */
#define CRAERR_SYS 69 /* Wenn System nicht funktioniert. Auch wenn
			 zuwenig virtual memory da ist */
#define CRAERR_INTERN 70 /* Die Applikation hat an sich selbst eine
			    Inkonsistenz festgestellt */
#define CRAERR_LIMIT 77 /* Eincompiliertes Limit ueberschritten */

     void cra_expand(char **base, char **current, char **end, size_t chunk);
     long cra_fsize(const char *const name);
     long lfroms(const char *const s, const size_t length);
     int cra_stdtime(time_t t, char *buf, const size_t length);
     
  /* Compatiblity functions, need GNU autoconf */

#ifndef HAVE_SNPRINTF
  int      snprintf(char *, size_t, const char *, ...);
#endif

#ifndef HAVE_VSNPRINTF
  int      vsnprintf(char *, size_t, const char *, va_list);
#endif

#ifdef HAVE_ALLOCA_H
#include <alloca.h>
#endif

#ifdef HAVE_ALLOCA
#define cra_alloca(__MACROP__) alloca(__MACROP__)
#define cra_afree(__MACROP__)
#else
  void	*cra_alloca(size_t);
  void	cra_afree(void *);
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_MACHINE_SOUNDCARD_H
#define CRA_SOUNDCARD_H <machine/soundcard.h>
#elif HAVE_SYS_SOUNDCARD_H
#define CRA_SOUNDCARD_H <sys/soundcard.h>
#elif HAVE_LINUX_SOUNDCARD_H
#define CRA_SOUNDCARD_H <linux/soundcard.h>
#endif

#endif /* This header file */
